%define name	sympa
%define version 5.4.3
%define release %mkrel 2

# ugly...
%define exceptions perl(\\(Net::LDAP\\|Archive\\|Commands\\|Conf\\|Language\\|Ldap\\|List\\|Log\\|Marc.*\\|Message\\|SympaTransport\\|Version\\|X509\\|cookielib\\|mail\\|smtp\\|wwslib\\|.*\.pl\\))
%define _provides_exceptions %{exceptions}
%define _requires_exceptions %{exceptions}

Name:		%{name}
Version:	%{version}
Release:	%{release}
Summary:	Electronic mailing list manager
License:	GPL
Group:		System/Servers
Source0:	%{name}-%{version}.tar.gz
Source1:	%{name}.init
Patch0:     %{name}-5.4.3-install.patch
Patch1:     %{name}-5.4.3-dont-redefine-constants.patch
URL:		http://www.sympa.org/
Requires:	apache-mod_fastcgi
Requires:	perl(CGI::Fast)
Requires:	perl(HTML::StripScripts::Parser)
Requires:	openssl >= 0.9.5a
Requires:	mhonarc >= 2.4.5
Requires:   mail-server
Requires:	perl-Crypt-CipherSaber
Requires:	perl-Template
Requires:	perl-MailTools
Requires(pre):	    rpm-helper
Requires(post):     rpm-helper >= 0.20.0
Requires(post):     mail-server
Requires(preun):    rpm-helper
Requires(preun):    mail-server
Requires(postun):   rpm-helper >= 0.16
BuildRequires:      rpm-helper >= 0.20.0
BuildRequires:      rpm-mandriva-setup >= 1.23
BuildRequires:	    openssl-devel >= 0.9.5a
BuildRequires:	    perl-MailTools
BuildRequires:	    perl-libintl-perl
BuildRequires:	    perl(HTML::StripScripts::Parser)
BuildRoot:          %{_tmppath}/%{name}-%{version}

%description
SYMPA is an electronic mailing list manager. It is used to automate list
management functions such as subscription, moderation and management of 
archives. SYMPA also manages sending of messages to the lists, and 
makes it possible to reduce the load on the system. Provided that you 
have enough memory on your system, Sympa is especially well adapted for big 
lists. For a list with 20 000 subscribers, it takes 5 minutes to send a
message to 90% of subscribers, of course considering that the network is 
available.

Documentation is available under HTML and SGML (source) formats. 

%prep
%setup -q
%patch0 -p 1
%patch1 -p 1
autoreconf

%build
%serverbuild
./configure \
	--prefix=%{_var}/lib/sympa \
	--with-mandir=%{_mandir} \
	--with-confdir=%{_sysconfdir}/sympa \
	--with-etcdir=%{_sysconfdir}/sympa \
	--with-cgidir=%{_var}/www/sympa \
	--with-bindir=%{_bindir} \
	--with-sbindir=%{_sbindir} \
	--with-libexecdir=%{_bindir} \
	--with-libdir=%{_datadir}/sympa/lib \
	--with-datadir=%{_datadir}/sympa \
	--with-expldir=%{_var}/lib/sympa/expl \
	--with-piddir=%{_var}/run/sympa \
	--with-localedir=%{_datadir}/locale \
	--with-scriptdir=%{_datadir}/sympa/script \
	--with-spooldir=%{_var}/spool/sympa \
	--with-initdir=%{_initrddir} \
    --with-docdir=%{_docdir}/%{name}-%{version} \
    --with-sampledir=%{_docdir}/%{name}-%{version}/sample \
    --with-sendmail_aliases=%{_var}/lib/sympa/aliases

%make sources wrapper soap_wrapper

%install
rm -rf %{buildroot}
%makeinstall_std

# Create bounce and archive incoming directories
for dir in bounce arc; do
  mkdir -p %{buildroot}%{_var}/spool/sympa/$dir
done

# Create bounce and archive storage directories
for dir in bounce arc www; do
  mkdir -p %{buildroot}%{_var}/lib/sympa/$dir
done

# Create PID directory
mkdir -p %{buildroot}%{_var}/run/sympa

# log directory
mkdir -p %{buildroot}/%{_var}/log/sympa

# logrotate
install -d -m 755 %{buildroot}%{_sysconfdir}/logrotate.d
cat > %{buildroot}%{_sysconfdir}/logrotate.d/sympa <<EOF
%{_var}/log/sympa {
	missingok
	notifempty
	copytruncate
}
EOF

# init script
install -m 755 %{SOURCE1} %{buildroot}%{_initrddir}/%{name}

# web stuff
pushd  %{buildroot}%{_var}/www/sympa
ln -s ../../lib/sympa/www/css .
ln -s ../../lib/sympa/www/pictures .
popd

# apache conf
install -d -m 755 %{buildroot}%{_webappconfdir}
cat > %{buildroot}%{_webappconfdir}/sympa.conf <<EOF
Alias /sympa %{_var}/www/sympa

<Directory "%{_var}/www/sympa">
    Options ExecCGI FollowSymlinks
    AddHandler fastcgi-script .fcgi
    DirectoryIndex wwsympa-wrapper.fcgi
    Allow from all
</Directory>
EOF

cat > README.urpmi <<EOF
Mandriva RPM specific notes
---------------------------

Updates
-------
This new release:
- default /wws Apache URL is now /sympa, for consistency with other webapps
- binaries are now installed in standard system locations (%{_bindir} and
  %{_sbindir}), whereas they were previously installed under
  %%{_libdir}/sympa/bin. package update procedure should automatically correct
  %them in your alias file, but may eventually fails.

Setup
-----
The setup used here differs from default one, to achieve better FHS compliance.
- the binaries are in %{_bindir} and %{_sbindir}
- the configuration files are in %{_sysconfdir}/sympa
- the constant files are in %{_libdir}/sympa and %{_datadir}/sympa
- the variable files are in %{_var}/lib/sympa
- the logs files are in %{_var}/log/sympa

Post-installation
-----------------
Sympa requires database for using the web interface. You have to create it
using the adequate script among %{_datadir}/sympa/script/db.

You can regenerate configuration files for sympa by executing
%{_sbindir}/sympa_wizard.pl

Additional useful packages
--------------------------
- perl-ldap for LDAP support
EOF

# sendmail secure shell
install -d -m 755 %{buildroot}%{_sysconfdir}/smrsh
ln -s %{_var}/lib/sympa/bin/queue %{buildroot}%{_sysconfdir}/smrsh/sympa

# Delete documentation in wrong places
rm -f %{buildroot}%{_sysconfdir}/sympa/README
rm -f %{buildroot}%{_datadir}/sympa/README

# Install remaining documentation manually
install -m 644 COPYING README NEWS README.urpmi %{buildroot}%{_docdir}/%{name}-%{version}

# don't install sudo wrapper, wwwsympa is setuid
rm -f %{buildroot}%{_var}/www/sympa/wwsympa_sudo_wrapper.pl

# don't install  bundled certs
rm -f %{buildroot}%{_datadir}/sympa/ca-bundle.crt

%find_lang sympa
%find_lang web_help
cat web_help.lang >> sympa.lang

%pre
%_pre_useradd sympa %{_var}/lib/sympa /bin/false

%post
%_post_service sympa
%_post_webapp

if [ $1 = 1 ]; then
  # installation

  # Setup log facility for Sympa
  facility=`%_post_syslogadd %{_var}/log/sympa/sympa.log`

  # sympa configuration
  hostname=`hostname`

  perl -pi \
    -e "s|^domain(\s+).*|domain\$1$hostname|;" \
    -e "s|^listmaster(\s+).*|listmaster\$1listmaster\@$hostname|;" \
    -e "s|^wwsympa_url(\s+).*|wwsympa_url\$1http://$hostname/sympa|;" \
    -e "s|^syslog(\s+).*|syslog\$1$facility|;" \
    %{_sysconfdir}/sympa/sympa.conf

  # Initial aliase file creation
  cat >> %{_var}/lib/sympa/aliases <<EOF
listmaster:	"|%{_bindir}/queue listmaster"
sympa:		"|%{_bindir}/queue sympa"
bounce+*:	"|%{_bindir}/bouncequeue sympa"
sympa-request:	listmaster@$hostname
sympa-owner:	listmaster@$hostname
EOF
  chown sympa.sympa %{_var}/lib/sympa/aliases

  # mta-specific aliases inclusion procedure
  mta="`readlink /etc/alternatives/sendmail-command 2>/dev/null | cut -d . -f 2`"
  if [ "$mta" == "postfix" ]; then
    database=`/usr/sbin/postconf -h alias_database`
    maps=`/usr/sbin/postconf -h alias_maps`
    postconf -e \
        "alias_database = $database, hash:%{_var}/lib/sympa/aliases" \
        "alias_maps = $maps, hash:%{_var}/lib/sympa/aliases"
  else
    cat >> %{_sysconfdir}/aliases <<EOF
:include:	%{_var}/lib/sympa/aliases
EOF
  fi
  /usr/bin/newaliases
else
  # find aliases file
  aliases=`awk '/sendmail_aliases/ {print $2}' %{_sysconfdir}/sympa/sympa.conf`
  if [ -z "$aliases" ]; then
    aliases=%{_sysconfdir}/aliases
  fi
  # correct pathes
  sed -i -e 's|%{_libdir}/sympa/bin|%{_bindir}|' $aliases
  # regenerate aliases
  /usr/bin/newaliases
fi

%preun
%_preun_service sympa

if [ $1 = 0 ]; then
  # uninstallation

  # clean syslog
  %_preun_syslogdel

  # remove aliases
  mta="`readlink /etc/alternatives/sendmail-command 2>/dev/null | cut -d . -f 2`"
  if [ "$mta" == "postfix" ]; then
    database=`/usr/sbin/postconf -h alias_database | \
      sed -e 's|, hash:%{_var}/lib/sympa/aliases||'`
    maps=`/usr/sbin/postconf -h alias_maps | \
      sed -e 's|, hash:%{_var}/lib/sympa/aliases||'`
    postconf -e \
      "alias_database = $database" \
      "alias_maps = $maps"
  else
    sed -i -e '/:include:   %{_var}/lib/sympa/aliases/d' \
      %{_sysconfdir}/aliases
  fi
  /usr/bin/newaliases
fi

%postun
%_postun_userdel sympa
%_postun_webapp

%files -f sympa.lang
%defattr(-,root,root)
%{_docdir}/%{name}-%{version}

# variable directories
%attr(-,sympa,sympa) %{_var}/lib/sympa
%attr(-,sympa,sympa) %{_var}/spool/sympa
%attr(-,sympa,sympa) %{_var}/run/sympa
%{_var}/log/sympa

# config files
%dir %{_sysconfdir}/sympa
%config(noreplace) %attr(640,root,sympa) %{_sysconfdir}/sympa/sympa.conf
%config(noreplace) %{_sysconfdir}/sympa/wwsympa.conf
%{_sysconfdir}/sympa/create_list_templates
%{_sysconfdir}/sympa/scenari
%{_sysconfdir}/sympa/task_models
%{_sysconfdir}/sympa/web_tt2
%{_sysconfdir}/sympa/mail_tt2
%{_sysconfdir}/sympa/general_task_models
%{_sysconfdir}/smrsh/sympa
%{_initrddir}/sympa
%config(noreplace) %{_sysconfdir}/logrotate.d/sympa
%config(noreplace) %{_webappconfdir}/sympa.conf

# binaries
%attr(-,sympa,sympa) %{_bindir}/queue
%attr(-,sympa,sympa) %{_bindir}/bouncequeue
%attr(-,sympa,sympa) %{_bindir}/familyqueue
%attr(-,root,sympa) %{_bindir}/aliaswrapper
%attr(-,root,sympa) %{_bindir}/virtualwrapper
%{_sbindir}/*

# other
%{_datadir}/sympa
%{_mandir}/man8/*

# web interface
%dir %{_var}/www/sympa
%{_var}/www/sympa/wwsympa.fcgi
%{_var}/www/sympa/sympa_soap_server.fcgi
%attr(-,sympa,sympa) %{_var}/www/sympa/sympa_soap_server-wrapper.fcgi
%attr(-,sympa,sympa) %{_var}/www/sympa/wwsympa-wrapper.fcgi
%{_var}/www/sympa/icons
%{_var}/www/sympa/css
%{_var}/www/sympa/pictures

%clean
rm -rf %{buildroot}


%changelog
* Mon Feb 16 2009 Guillaume Rousse <guillomovitch@mandriva.org> 5.4.3-2mdv2009.0
+ Revision: 341078
- add forgotten LOCK_UN symbol in patch, fixing code compilation

* Sun Jul 06 2008 Guillaume Rousse <guillomovitch@mandriva.org> 5.4.3-1mdv2009.0
+ Revision: 232181
- new version
- sync init script with mailman one
- use a single url prefix for all web stuff
- new version
- update install patch
- install cgi files under /var/www/sympa
- mysql dependency in init scrip

  + Pixel <pixel@mandriva.com>
    - adapt to %%_localstatedir now being /var instead of /var/lib (#22312)

* Mon Feb 18 2008 Thierry Vignaud <tvignaud@mandriva.com> 5.3.4-2mdv2008.1
+ Revision: 171135
- rebuild
- fix "foobar is blabla" summary (=> "blabla") so that it looks nice in rpmdrake

* Wed Feb 06 2008 Guillaume Rousse <guillomovitch@mandriva.org> 5.3.4-1mdv2008.1
+ Revision: 163224
- new version

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Thu Sep 06 2007 Guillaume Rousse <guillomovitch@mandriva.org> 5.3.3-1mdv2008.0
+ Revision: 80909
- use new syslog rpm-helper
- new version

* Thu Jun 07 2007 Guillaume Rousse <guillomovitch@mandriva.org> 5.3.1-1mdv2008.0
+ Revision: 36757
- new version
  fix monharc dependency capitalization

* Sun Jun 03 2007 Guillaume Rousse <guillomovitch@mandriva.org> 5.3-1mdv2008.0
+ Revision: 34888
- final version

* Sun Jun 03 2007 Guillaume Rousse <guillomovitch@mandriva.org> 5.3-0.beta4.2mdv2008.0
+ Revision: 34884
- new mandriva specific FHS-compliant init script

* Wed May 30 2007 Guillaume Rousse <guillomovitch@mandriva.org> 5.3-0.beta4.1mdv2008.0
+ Revision: 32945
- new version


* Thu Mar 08 2007 Guillaume Rousse <guillomovitch@mandriva.org> 5.3-0.beta1.2mdv2007.1
+ Revision: 134999
- don't remove aliases file on removal, just remove it from system aliases configuration, as mailman

* Wed Mar 07 2007 Guillaume Rousse <guillomovitch@mandriva.org> 5.3-0.beta1.1mdv2007.1
+ Revision: 134290
- use alias_database and alias_maps directives for postfix, so as to make newaliases command functionnal
- use get_free_syslog_facility helper script
- new version, using standard pre-release versionning scheme
- main configuration file is supposed to contains a password
- uses a patch instead of in-spec substitutions to handle installation, so as to fix insane perms also
- install wrappers setuid root

* Wed Nov 15 2006 Guillaume Rousse <guillomovitch@mandriva.org> 5.3a.10-1mdv2007.1
+ Revision: 84462
- attempt to migrate aliases automatically during upgrade
  use alias_database insteaf of alias_maps for postfix, as it allow to use sendmail-compatible newaliases command
- remove aliase database also on uninstallation
- fix listmaster adress substitution
- all sympa-created static web content is now created in %%_localstatedir/sympa/www
  change Apache alias from wws to sympa, for consistency with other webapps
- no need to create log file, syslog will do it alone
- fix syslog modification in %%preun
- fix alias removal during %%preun
- sanitize permissions
- sanitize setup a little bit:
- executables are in system standard directories (%%_bindir and %%_sbindir)
- samples are in documentation
- scripts are not samples
- sanitize macro use
- new version
- use a distinct alias file in /var/lib/sympa, and make sure it is included by MTA
- ship all documentation
- fix openssl path
- fix %%post
- LDAP support is optional
- move runtime-independant configuration change from %%post to %%install
- yet more cleanup
- ready-to-use static css directory
- fix %%post scriptlet
- put static web content (icons) into their own directory
- put messages files in correct place
- no need to add apache in sympa group, wwsympa is setuid
- useless verbosity
- don't install wrapper, wwsympa is setuid
- sanitize automatic configuration a little bit:
- dont use NIS domain name at all
- use hostname rather than domain name, as it is a safer default
- chain regexpes
- better regexp coherency
- correctly setup log facility in sympa configuration
- drop commented lines
- use herein document for README.urpmi
  more explicit instructions
- don't mess with mysql database creating script, as it breaks it
- use new webapps macros, allowing to discard versioned apache dependencies
  no need to requires mails-server during %%pre
- Import sympa

* Mon Jun 05 2006 Anne Nicolas <anicolas@mandriva.com> 5.2.1-1mdk
- new version, bug fix

* Wed May 17 2006 Anne Nicolas <anicolas@mandriva.com> 5.2-2mdk
- fix sympa.conf configuration for hostname

* Fri Apr 21 2006 Anne Nicolas <anicolas@mandriva.com> 5.2-1mdk
- update of translations
- performances optimization
- full virtual hosting support

* Sun Feb 05 2006 Anne Nicolas <anicolas@mandriva.com> 5.1.2-1mdk
- new version, bug fix

* Thu Sep 01 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 5.1.0-2mdk
- buildrequires: perl-libintl-perl (Locale/Messages.pm)

* Sun Aug 28 2005 Anne Nicolas <anicolas@mandrakesoft.com> 5.1.0-1mdk
- new version
- add perl-Template require
- modify configure adding --with-docdir
- modify Makefile searching

* Thu Jul 14 2005 Guillaume Rousse <guillomovitch@mandriva.org> 4.1.5-2mdk 
- new mail-server requires
- new apache setup
- new apache macros
- use herein documents instead of additional sources
- ship sendmail secure shell link instead of managing it through post-installation procedure
- spec cleanup
- use %%mkrel

* Sat Feb 26 2005 Anne Nicolas <anicolas@mandrakesoft.com> 4.1.5-1mdk
- new version

* Fri Feb 18 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 4.1.4-2mdk
- spec file cleanups, remove the ADVX-build stuff
- strip away annoying ^M

* Thu Feb 10 2005 Anne Nicolas <anne@mandrakesoft.com> 4.1.4-1mdk
- new version because of bug in web interface

* Tue Feb 08 2005 Anne Nicolas <anne@mandrakesoft.com> 4.1.3-1mdk
- new version (last one for this branch)

* Mon Nov 01 2004 Michael Scherer <misc@mandrake.org> 4.1.2-5mdk
- Buildrequires perl-MailTools

* Sat Oct 23 2004 Anne Nicolas <anne@mandrake.org> 4.1.2-4mdk
- use README.urpmi feature (thanks to rgs and misc)

* Sat Oct 23 2004 Anne Nicolas <anne@mandrake.org> 4.1.2-3mdk
- fix bug in mysql database creation script
- add comment about database creation at the end of install

* Thu Aug 05 2004 Anne Nicolas <anne@mandrake.org> 4.1.2-2mdk
- create sympa directory in /var/log for sympa's logs
- modify syslog : log all priorities in /var/log/sympa/sympa.log

* Thu Jul 08 2004 Anne Nicolas <anne@mandrake.org> 4.1.2-1mdk
- add apache configuration for wws
- remove patch for init file
- new version

* Sat Apr 24 2004 Anne Nicolas <anne@mandrake.org> 4.1.1-3mdk
- add SympaTransport exception
- add require perl-MailTools

* Fri Apr 23 2004 Olivier Blin <blino@mandrake.org> 4.1.1-2mdk
- merge changelog from the real 3.4.4.3-4mdk release to let the package be uploaded again (after a three months break)

* Thu Apr 22 2004 Guillaume Rousse <guillomovitch@mandrake.org> 4.1.1-1mdk
- new version, by popular demand (you know who you are)
- no more explicit perl dependencies, let spec-helper do its job

* Thu Apr 08 2004 Guillaume Rousse <guillomovitch@mandrake.org> 3.4.4.3-5mdk
- fixed multiple groups handling when adding sympa to apache group (Francis Muguet <muguet@ensta.fr>)
- requires mod_fastcgi and install cgi in correct dir (Guillaume Sauvenay <sauvenay@ccr.jussieu.fr>)
- user rpm-helper facility to create empty files

